\chapter{Theory}

This chapter is divided into three sections.
The first will introduce physical models and equations for the phase transition.
In the second one, the phase field method will be discussed as a general model
for phase transitions.
The third section deals with numerical methods used for simulations based on
the phase field model.

\section{Phase Transition Kinetics}
  
  For the transformation of a material from one phase to another,
  two mechanisms are of interest~\citep{balluffi}.
  Nucleation is the spontaneous formation of small parts of the new phase,
  called nuclei.
  Existing nuclei grow with a velocity dependent on material and enviromental
  properties.
  For some of these properties, seperate models are discussed.
  Finally, from these behaviours an analytical equation for the mean transformed
  fraction can be calculated in the Johnson-Mehl-Avrami-Kolmogorov (JMAK) model.
  
  \subsection{Classical Nucleation Theory}
    The transition of a material from a metastable phase $\Theta$ into an
    energetically favourable phase $\Omega$ starts from small nuclei that form
    due to thermal movement.
    To describe the kinetics of the phase transition, a quantity of interest is
    the rate at which this nuclei form.
    Normalised to the volume, it is called nucleation rate $J$.
    
    The classical theory of nucleation splits the change in
    free energy $G$ resulting from the formation of a nucleus into
    a bulk free energy and an interfacial energy~\citep{balluffi}.
    The bulk free energy $\dGv$ is the difference in free energy between the
    two phases neglegting interfaces, normalised to the volume $V$.
    It is defined to be positive, although the effect described by it leads to
    a negative change in free energy at the formation of a nucleus.
    \begin{equation}
     \dGv = \frac{G_\Omega - G_\Theta}{V} > 0
    \end{equation}
    The energetically higher structures at the interface are considered in the
    interfacial energy per area $A$:
    \begin{equation}
     \gamma = \frac{G_{\text{Interface}}}{A}
    \end{equation}
    Separating this is an approximation for thin interface regions compared to
    the size of a nucleus.
    
    Without additional effects, a spherical nucleus has the lowest ratio
    of area to volume and thus the lowest energy barrier.
    For this shape the free energy change $\Delta G$ can be expressed
    as a function of the radius $r$:
    \begin{align}
     \Delta G &= - V \cdot \dGv + A \gamma \\
	      &= - \frac{4 \pi}{3} r^3 \dGv + 4 \pi r^2 \gamma
     \label{eq:cnt_freeEnergy}
    \end{align}
    
    The critical nucleus is the smallest nucleus that will continue
    to grow larger instead of shrinking and vanishing~\citep{balluffi}.
    It corresponds to the maximum in $\Delta G$,
    for which one finds the critical radius
    \begin{align}
     r_c = \frac{2\gamma}{\dGv}
     \label{eq:cnt_rcrit}
    \end{align}
    and, substituting this into eq.~\ref{eq:cnt_freeEnergy}, the height of the
    energy barrier, which is also called critical energy
    \begin{align}
     \Delta G_c = \frac{16 \pi \gamma^3}{3\dGv^2} \ .
    \end{align}
    
    In thermodynamic equilibrium at a temperature $T$,
    the sizes of clusters of phase $\Omega$
    follow a Boltzmann distribution~\citep{balluffi}.
    $J$ is proportional to the concentration of critical nuclei,
    so to $e^{\frac{-\Delta G_c}{k_B T}}$,
    where $k_B$ is the Boltzmann constant.
    
    It is also proportional to the rate $\beta$ at which nuclei of a smaller
    size grow to the critical size~\citep{balluffi}.
    This factor is given as $\beta = j_f \cdot n_c^{(2/3)}$.
    The frequency $j_f$, at which atoms jump on and off the crystal, can be
    calculated using the Stokes-Einstein relation~\citep{NucleationTheory}
    \begin{equation}
     j_f = \frac{k_B T}{3 \pi \lambda^3 \eta}
    \end{equation}
    with the distance $\lambda$ for such a jump and the viscosity $\eta$,
    which is itself strongly temperature dependent~\citep{NucleationTheory}
    and further discussed in an own section.
    The factor $n_c^{(2/3)}$ describes the number of atoms at the surface
    that can jump onto the crystal.
    Here, $n_c$ is the number of atoms in a critical nucleus and can be
    calculated from its volume and the volume per atom $V_m$:
    \begin{equation}
     n_c = \frac{4 \pi}{3} r_c^3 \cdot \frac{1}{V_m}
         = \frac{32 \pi \gamma^3}{3 \dGv^3 V_m} \ .
    \end{equation}
    
    Additional effects are considered in the Zeldovich factor
    \begin{equation}
     Z = \frac{3 V_m}{4 \pi r_c^3} \sqrt{\frac{\Delta G_c}{3 \pi k_B T}} \ ,
    \end{equation}
    which takes into account that the actual concentration of critical nuclei
    during nucleation is lower than in equilibrium
    (as larger nuclei often grow to large clusters of $\Omega$ phase
    and thus leave the considered $\Theta$ phase)
    and that many supercritical nuclei decay again~\citep{balluffi}.
    
    Alltogether, one gets
    \begin{align}
     J &= \frac{\beta Z}{V_m} e^{\frac{-\Delta G_c}{k_B T}} \\
       &= \frac{k_B T n_c^{(2/3)}}{4 \pi^2 \lambda^3 r_c^3 \eta}
          \sqrt{\frac{\Delta G_c}{3 \pi k_B T}}
          e^{\frac{-\Delta G_c}{k_B T}} \ .
     \label{eq:cnt_J}
    \end{align}
    
    For a finite time $t$ and volume $V$, the number of grains follows
    a Poisson distribution.
    For more than one nucleus, this neglects the shrinking volume due to the
    other nuclei, which does however not alter the probability for zero nuclei.
    Thus, the probability $P$ of at least one nucleation event
    is given as~\citep{balluffi}
    \begin{equation}
     P(t,V) = 1-e^{-J V t} \ .
    \end{equation}
    
    One effect beyond this equation is the incubation time.
    Starting from a system entirely in phase $\Theta$
    (with negligible amount of $\Omega$ phase nuclei),
    some time passes until the eqilibrium distribution is reached.
    This leads to a rate starting from zero and increasing after some time
    up to the calculated rate $J$.
    In figure~\ref{fig:cnt_incubationtime}, this effect can be observed
    in experimental data.
    
    \begin{figure}[tb]
      \centering
      \includegraphics[width=.5\linewidth]{../img/exp_incubationtime.png}
      \caption{Number of nuclei over time, taken from the
          experimental data~\citep{expdata}.
	  After an incubation period, the nuclei form with a constant rate.
	  The crystallization does not considerably change the free volume in the
	  shown time.}
      \label{fig:cnt_incubationtime}
    \end{figure}
    
%     The overall rate of new grains, $\frac{dN}{dt}$, is the product of $J$
%     and the volume of phase $\Theta$ in which nucleation can occur.
%     In the process of phase transition, this volume decreases and vanishes.
%     Thus, $\frac{dN}{dt}$ decreases and vanishes and $N$ converges
%     to a final number of grains.
    
    A second additional effect is heterogeneous nucleation at surfaces
    between the material and surrounding structures.
    The interfacial energies $\gamma_{\Theta \Omega}$, $\gamma_{\Theta S}$,
    $\gamma_{\Omega S}$ between material of phase $\Theta$ and $\Omega$ and
    structures $S$ are in general different.
    If $\gamma_{\Omega S} < \gamma_{\Theta \Omega}$, a nucleus on the surface can
    have a lower energy barrier, which leads to a higher rate of nucleation
    at these surfaces.
    
    Other effects, like anisotropies that lead to non spherical nuclei
    or stresses in the material due to the phase transition,
    can also be considered in this theory,
    but are not used in this work.
    
  \subsection{Growth}
    \label{sec:theo:v}
    The counterpart to the nucleation is the growth of existing grains.
    For the velocity of this process, there are different models
    that have been used for different materials and temperature ranges.
    
    Most experiments are performed on a limited temperature range and use
    a single model to describe the results.
    The used models differ however for the different temperature ranges
    and lead to contradictory results for the intermediate ranges.
    Some authors who analyse data over the full temperature range introduce
    a glass transition temperature $T_{glass}$ and use different models
    above and below this temperature~\citep{crystalGrowthInPcm}.
    
    \subsubsection{Arrhenius Model}
      Many processes that require an activation energy $E_a$ are proportional to
      a Boltzmann factor $\exp(\frac{- E_a}{k_B T})$,
      according to statistical mechanics~\citep{easterlingporter}.
      It is then reasonable to plot the logarithm of this quantiy, here $v$,
      over $1/T$, which is called an Arrhenius plot.
      If the activation energy is temperature independend and the activation
      energy barrier is the dominant effect,
      this plot can often be described by a linear function.
      For the growth velocity of a crystal grain, this is often the case for 
      lower temperatures~\citep{SbTeArrhenius}.
      It is then calculated as
      \begin{equation}
       v(T) = v_\infty e^{\frac{- E_a}{k_B T}} \ .
      \end{equation}
      In this form, the equation is mostly used for data with low precision or
      over a limited temperature scale.
      Elsewhere, several modifications are used to improve the
      consistency~\citep{arrheniusDevelopement}.
      
      Originally proposed as an approximation for empirical data on chemical
      reaction rates~\citep{easterlingporter},
      this function is also used to describe the growth velocity in phase change
      materials.
      Compared to other models, this one is especially used for lower
      temperatures.
      
      It has been applied for
      GeTe~\citep{geteExperimentsOld, geteNucleationAndGrowth},
      AIST and several GeSbTe alloys~\citep{SbTeArrhenius, crystalGrowthInPcm}.
      All of these experiments were done with temperatures ranges of about
      $\SI{100}{K}$ length, with values below $\SI{500}{\K}$.
      
      An example for a modificated Arrhenius function in the context of phase
      change material is the assumption of Arrhenius behaviour
      for the mobility\footnote{There are two different quantities in this
      thesis that are called ``mobility'', $\mu$ and $M$.
      Both are a ratio between the growth velocity and its driving force,
      but defined differently.
      If not stated otherwise, the word referes to $M$}
      $\mu = \frac{v}{\dGv}$,
      which was used for AIST~\citep{AISTpaper}.
      For the growth velocity, this yields
      \begin{equation}
       v = \mu_\infty \cdot \dGv \cdot e^{\frac{- E_a}{k_B T}} \ ,
      \end{equation}
      with a temperature dependent prefactor $\dGv$.
    
    \clearpage
    \subsubsection{Frenkel Model}
      At higher temperatures, the activation energy barrier is not the dominant
      effect, so the growth velocity does not follow an Arrhenius function.
      The Frenkel model is often used for crystal growth at these
      temperatures~\citep{crystalGrowthInPcm}.
      It calculates the velocity as
      \begin{equation}
       v = v_{kin} \cdot \left(1-\exp\left(\frac{-\Delta G}{k_B T}\right)\right) \ .
      \end{equation}
      The factor $v_{kin}$ describes the formation of new crystallized material
      next to the surface,
      while the factor in brackets is associated with the probability for the
      newly formed crystal material to remain in the
      structure~\citep{frenkelmodel}.
      The free energy difference $\Delta G$ is meant per atom and can be
      calculated using the model for $\dGv$ with a latent heat per atom.
      Note that for lower temperatures $\Delta G$ gets larger and $k_B T$
      smaller, so that $v \approx v_{kin}$.
      
      Using Einstein-Stokes relation, $v_{kin}$ can be expressed as
      \begin{equation}
       v_{kin} = \frac{4 k_B T r_{atom}}{3 \pi \lambda^2 R_{hyd}} \cdot \frac{1}{\eta}\ ,
      \end{equation}
      where $\lambda$ is the jump distance and $r_{atom}$ and $R_{hyd}$ are the
      atomic respectively hydrodynamic radius.
      For the viscosity $\eta$, there are different models used,
      which typically show an exponential temperature dependence.
      Thus, the linear dependence in this equation is sometimes neglegted.
      This leads to
      \begin{equation}
       v_{kin} = \tilde{A} \cdot \frac{1}{\eta}
      \end{equation}
      with a fit parameter $\tilde{A}$.
      
      In the context of phase change materials, this model has been used for
      AIST~\citep{AistExperiments} and
      \GSTxxx{2}{2}{5}~\citep{crystalGrowthInPcm} in the first form, for
      GeTe~\citep{geteExperimentsNew} in the simplified second one.
  
  \clearpage
  \subsection{Viscosity}
    For the viscosity, the same arguments apply as for the velocity regarding
    the glass transition temperature.
    
    \subsubsection{Arrhenius Model}
      \label{sec:arrheniusviscosity}
      An Arrhenius equation can also be used to
      describe the reciprocal viscosity~\citep{NucleationTheory}.
      The viscosity is thus calculated as
      \begin{equation}
       \eta = \eta_\infty \exp\left(\frac{E_a}{k_B T}\right)
      \end{equation}
      (without a minus sign in the exponent).
      
      Combining this with the Frenkel model for low temperatures,
      this leads to an Arrhenius behaviour for the growth velocity.
      As this is often a good approximation for low temperatures, this model
      allows to use the Frenkel model in this temperature range.
      For higher temperatures however, this model does not hold.
      It is however sometimes combined with another model to cover large
      ranges of temperatures.
    
    \subsubsection{MYEGA Model}
      Similar to the growth velocity, for higher temperatures there are
      deviations from the Arrhenius equation.
      A model that is often used for glass forming liquids is the
      Mauro-Yue-Ellison-Gupta-Allan~(MYEGA)~model~\citep{geteExperimentsNew},
      which occurs however with slight variations:
      \begin{align}
	\log_{10}(\eta) &= \log_{10}(\eta_{\infty})
	      + (12-\log_{10}(\eta_{\infty})) \frac{T_g}{T}
	        \exp\left( \left(\frac{m}{12-\log_{10}(\eta_{\infty})} \right)
	          \left(\frac{T_g}{T} - 1 \right) \right) \\[1ex]
	\log_{10}(\eta) &= \log_{10}(\eta_{\infty})
	      + (12-\log_{10}(\eta_{\infty})) \frac{T_g}{T}
	        \exp\left( \left(\frac{m}{12-\log_{10}(\eta_{\infty})} - 1 \right)
	          \left(\frac{T_g}{T} - 1 \right) \right)
      \end{align}
      The viscosity for infinite temperature $\eta_\infty$ is normally different
      from the one in the Arrhenius model.
      The parameter $T_g$ is often referred to as glass transition temperature.
      This name is however also used for a different temperature $T_{glass}$,
      at which this model is exchanged to an Arrhenius model for lower
      temperatures~\citep{crystalGrowthInPcm}.
      The last coefficient is the fragility $m$.
      
      The first form of the model has been used for AIST~\citep{AISTpaper} and
      GeSb~\citep{CrystallizationKinetics}.
      The second form has been used for \GSTxxx{2}{2}{5}~\citep{crystalGrowthInPcm} and
      GeTe~\citep{geteExperimentsNew}.
      These experiments were either performed at high temperatures,
      or they use this model for temperature above $T_{glass}$ and switch to an
      Arrhenius model for lower temperatures.
    
    \subsubsection{C\&G Model}
      An alternative to the MYEGA model is the Cohen and Grest (C\&G) model.
      It is also applicable for glass forming liquids and thus for
      phase change materials at high temperatures~\citep{geteExperimentsNew}.
      The viscosity is calculated as
      \begin{equation}
	\log_{10}(\eta) = A + \frac{2 B}{T - T_0 + \sqrt{(T-T_0)^2 + 4 C T}}
      \end{equation}
      where $A$, $B$, $C$ and $T_0$ are free parameters for a fit.
      
      It has been used for GeTe~\citep{geteExperimentsNew} and 
      GeSb~\citep{CrystallizationKinetics} as an alternative
      to the MYEGA model.
  
  \subsection{Bulk Free Energy}
    The difference in Gibb's free energy between the two phases
    is the driving force for growth of crystal nuclei
    (cf. eq.~\ref{eq:velocity})
    and also appears in the nucleation theory.
    For the free energy of glass forming alloys, several approximations have
    been reviewed by~\citet{FreeEnergyDerivation}.
    From melting temperature down to half of it, they find the
    Thompson and Spaepen equation
    \begin{equation}
    \dGv = L \frac{T_m-T}{T_m} \frac{2 T}{T_m + T}
    \end{equation}
    to be a good approximation.
    Besides, it has the advantage not to depend on many or difficult to
    measure parameters.
    The latent heat per volume $L$ and the melting temperature $T_m$ are
    known for most materials of interest.
    This equation has been used for phase change materials by several authors
    and a wide range of materials~\citep{CrystallizationKinetics, SbTeArrhenius,
    AistExperiments, crystalGrowthInPcm, geteExperimentsNew}.
  
  \subsection{Interfacial Energy}
    At the interface between two phases, energetically higher structures
    exist to fit the two structures together~\citep{balluffi}.
    This energy per unit of interfacial area is called
    interfacial energy $\gamma$.
    
    The value is assumed to be temperature independent by most
    authors~\cite{AISTpaper, NucleationTheory}.
    
    It plays a role in the classical nucleation theory as the main cause
    preventing the formation of nuclei.
    The ratio of $\gamma$ to the bulk free energy defines the critical radius.
    The energy barrier $\Delta G_c$ is proportional to $\gamma^3$ and appears in
    the exponent for the calculatio of the nucleation rate $J$.
    From a fit to the equation from this theory, a value can be estimated,
    which is one way to determine this parameter~\citep{SbTeArrhenius}.
    
    It is also responsible for the Gibbs-Thomson effect.
    The growth of a grain raises the interface area and thus the free energy.
    This slows down the growth, wich is driven by a reduction of the free
    energy~\citep{PFMintro3}.
    In classic sharp-interface models, the time evolution for the radius $r$
    of a grain is given by~\citep{gibbsthompson}
    \begin{equation}
     \frac{dr}{dt} = \mu \left( \dGv - \frac{\gamma}{r} \right) \ ,
     \label{eq:gibbsthompson}
    \end{equation}
    where $\mu = v / \dGv$ is a mobility.
    As the interface grows with $r^2$, while the volume grows with $r^3$,
    the effect vanishes with $r^{-1}$.
  
  \subsection{JMAK Theory}
    The main quantity of interest is the fraction $f_c$ of the material that
    already crystallized as function of time.
    In the Johnson-Mehl-Avrami-Kolmogorov (JMAK) theory,
    an analytical equation for this function can be calculated~\citep{jmakReview}.
    
    Originally, the theory was derived from a probabilistic point of view:
    The crystallized fraction of the material equals to the probability for an
    arbitrary point to be crystallized.
    An alternative way directly integrates the crystallized fraction.
    The volume at time $t$ of a grain
    that appeared (with negligible size) at time $\tau$
    and grew with a constant rate $v$
    and without any obstacles
    is $\frac{4 \pi}{3} v^3 (t-\tau)^3$.
    Multiple grains eventually grow into each other and will not continue
    to grow according to this equation afterwards.
    In a first step however, this will be ignored.
    The resulting quantity is often called extended crystallized
    volume~$V_{ext}$~\citep{jmakReview}.
    Consider a volume $V$ at a time $t$.
    To calculate this extended crystallized volume,
    one can integrate over all possible nucleation times $\tau$,
    consider the nuclei appearing in that time and add their volume.
    The number of nuclei $dN$ forming in a time $d\tau$ is $J V d\tau$.
    Thus, one gets
    \begin{align}
     \label{eq:jmak_Vext}
     V_{ext} &= \int_0^t \! d\tau \, J \cdot V \cdot \frac{4 \pi}{3} v^3 (t-\tau)^3 \\[1ex]
             &= \frac{\pi}{3} J V v^3 t^4 \ .
    \end{align}
    This equation leads to
    \begin{align}
     \frac{d V_{ext}}{dt} = \frac{4 \pi}{3} J V (v t)^3 \ .
    \end{align}
    The growth of the real crystallized volume is smaller than this
    by a factor $(1-\frac{V_c}{V})$,
    as on average only this ratio of the volume is free to crystallization.
    This leads to
    \begin{equation} 
     \frac{d V_c}{dt} = \frac{\pi}{3} J V (v t)^3 \cdot \left( 1-\frac{V_c}{V} \right) \ .
    \end{equation}
    Integrating this equation with $V_c(t=0)=0$ gives
    \begin{equation}
     V_c = V \cdot \left( 1 - e^{-\frac{\pi}{3} J v^3 t^4} \right) \ .
    \end{equation}
    
    The general form of this equation is
    \begin{equation}
     f_c = 1 - e^{-V_{ext}(t)} \ .
    \end{equation}
    Other equations for the extended volume can be used.
    In thin layers, the growth is effectively limited to two dimensions.
    For a thickness $d \ll vt$, an extended volume can be calculated as
    \begin{equation}
     V_{ext} = \frac{\pi}{3} d v^2 t^3 \ .
    \end{equation}
    
    It is also possible to include non constant growth velocities
    in the equation, caused for example by a Gibbs-Thomson effect.
    This often means that the integral~\ref{eq:jmak_Vext} can not
    be solved analytically, so that it remains in the final
    equation~\citep{balluffi}.
    
    \pagebreak
    However, there are several problematic assumptions that enter
    this calculation: \nopagebreak
    \begin{itemize}
     \item There are no effects included regarding the boundaries of the
      material. Thus, an infinite space is assumed.
     \item Nucleation is assumed to occur homogeneously in the material,
      heterogeneous nucleation at material boundarys is not considered.
     \item Only homogeneous growth velocities are considered.
      As the groth velocity is usually temperature dependent,
      this implies an even temperature in the whole material.
    \end{itemize}
    
    In addition, there are several more quantities of interest
    than the calculated crystallized fraction.
    This includes the size, number and form of the grains,
    which can have huge influence on material properties~\citep{PFMintro1}
    and are not calculated in the JMAK model.
  
\section{Phase Field Method}
  The phase field method has become a powerful tool not only for solid state
  transformations, but also for solidification, participate growth,
  cell membranes and others~\citep{PFMintro1, PFMintro3}.
  It could become the link between atomic calculations on the microscale
  and macroscopic simulations.
  
  In the phase field model, properties of a system are described
  as continuous fields.
  Interfaces are not, as in many other models, assumed to be sharp, but occupy
  a finite thickness.
  This allows to derive one single time evolution equation per field,
  which leaves behind the computational challenging task of explicitly tracking
  the interface.
  
  There are in general two types of phase field parameters~\citep{PFMintro1}: \\
  The first one are physical parameters with a direct meaning,
  such as concentrations, magnetisation or long range order parameters.
  For these, time evolution equations can be derived from microscopic models. \\
  The second type are phenomenological parameters that are introduced ad-hoc to
  use the phase field model rather than a sharp interface description.
  Here, the evolution equations do not come from microscopic models,
  but from fits to experimental data~\citep{PFMintro1}.
  
  In presence of different phases, most physical models state different
  equations for each phase, with boundary conditions at the phase border,
  together with an equation for the movement of the border~\citep{balluffi}.
  To solve this numerically, the current position of the interface must be
  explicitly tracked. This is especially complicated for complex shapes. \\
  Different from this, the phase field model uses a diffuse interface
  description. It is then possible to define a single time evolution equation
  that covers the behaviour in all phases
  as well as the interface movement~\citep{PFMintro1}.
  With the Allen-Cahn and Cahn-Hillard equations, there are methods
  to derive such equations for non conserved resp. conserved quantities
  from a free energy formula.
  
  Several quantities can be coupled and additional effects,
  such as elastic or electric energies,
  can easily be included by adding terms to the free energy.
  This allows to simulate them together to get a consistent result.
  
  In comparison to the JMAK model,
  the phase field model offers a more consistent description that can
  include effects coming from material boundarys, non spherical grain shapes
  and additional energy terms.
  It offers information about grain size and shape,
  but for the price of a much higher computational effort.
  
  In comparison to sharp interface models,
  the computational effort is reduced.
  This allows calculations without assumptions on the shape of grains,
  a simplification often done in these models.
  However, details might be lost if the interface width differs from physically
  sensible values.  
  
  \subsection{Phase Field Equation}
    The phase field parameter used in simulating the phase transition of a phase
    change material belongs to the phenomenological kind.
    The order parameter $\Phi(\vec{x})$ shall be $0$ in the amorphous phase and $1$
    in the crystalline phase.
    
    As a non conserved quantity, its evolution is given by the Allen-Cahn
    equation, also referred to as Ginzburg-Landau equation~\citep{PFMintro1}:
    \begin{equation}
     \frac{d \Phi}{dt} = - M \frac{\delta G(\Phi(\vec{x}))}{\delta \Phi(\vec{x})}
     \label{eq:allencahn}
    \end{equation}
    
    It is a process driven by a reduction of
    the Gibbs free energy $G$~\citep{PFMintro3},
    which is mathematically given as a functional of the field $\Phi(\vec{x})$.
    The mobility\footnote{Not to be confused with $\mu$, which is also called
    mobility}
    $M$ is a parameter to be determined later, which can depend on
    material and enviromental properties and thus be position dependent.
    Most of the behaviour is defined via the free energy $G(\Phi)$.
    
    The free energy consists of a bulk free energy
    and an interfacial term~\citep{PFMintro1}. \\
    As derived by Cahn and Hillard~\citep{CahnHillard}, it can be written as
    \begin{equation}
     G(\Phi) = \intdV \left( g(\Phi(\vec{x})) +
                       \frac{\epsilon^2}{2} (\nabla \Phi(\vec{x}))^2 \right) \ .
      \label{eq:cahnhillardG}
    \end{equation}
    They showed that differentials of odd order have to vanish,
    as well as other terms of second order~\citep{PFMintro2}.
    
    The second term is called gradient energy term.
    As it vanishes in full crystalline or amorphous domains
    where $\Phi$ is constant at the eqilibrium value,
    it contributes to the interfacial energy.
    With a positive $\epsilon^2$, it assinges a high energy to steep interfaces
    and thus leads to a wider interface the higher it is~\citep{PFMintro1}.
    A value for it is determined
    from the required properties of the interface~\citep{PFMintro2}.
    
    The free energy per volume $g(\Phi,\vec{x})$ can again be split
    in two parts.
    A phase separation takes place when a thermodynamic potential has a double
    well form as a function of an extensive quantity~\citep{balluffi}.
    Assinging $\Phi = 0$ and $\Phi = 1$ to the eqilibrium configurations,
    such a form can in lowest order be written as
    \begin{equation}
     W \Phi^2 (1-\Phi)^2 \ .
    \end{equation}
    This term is again zero in both phases and assinges a positive energy to the
    interface region.
    A deeper double well (a higher depth $W$) thus leads to a steeper interface.
    Confining the domain of $\Phi$ to values from $0$ to $1$,
    one can alternatively choose for example $W \Phi (1-\Phi)$,
    which leads to a different interface form~\citep{AISTpaper}.
    This freedom of choice enables to choose a form that leads to analytically
    solveable settings.
    It can however lead to a loss of detail when simulating with a resolution on
    the scale of the physical width of the interface.
    
    In contrast, a phase transition takes place when one phase has a lower free
    energy than the other.
    In $g(\Phi)$ this can be considered by lowering the minimum corresponding to the
    energetically favourable state by the free energy difference $\dGv$
    while keeping the other at zero.
    To keep equation~\ref{eq:cahnhillardG} well defined, this has to be done with a
    differentiable function whose derivative vanishes for $\Phi = 0$ and
    $\Phi = 1$, so that these are stable values.
    There are however no more informations
    about the functional form~\citep{PFMintro2},
    so that the same arguments apply as for the double well term.
    To get some analytically solveable settings,
    \begin{equation}
     \dGv  \Phi^2 (2\Phi - 3)
    \end{equation}
    is a good choice~\citep{PFMSolidification}.
    For the form to be a double well, the second derivative must be positive at
    the equilibrium points,
    which yields 
    \begin{equation}
     W > 3 \dGv
     \label{eq:doublewellrestriction}
    \end{equation}
    for this form.
    Otherwise, the eqilibrium at $\Phi = 0$ will not be stable,
    which is not the physically intended situation.
    This restriction to the parameters can be abolished by confining the domain
    of $\Phi$ or changing the functional form outside of the relevant domain.
    
    Together, the free energy functional is
    \begin{align}
    G = \intdV \left( \frac{\epsilon^2}{2} (\nabla \Phi)^2 
                        - \dGv \Phi^2 (3-2\Phi)
                        + W \Phi^2(1-\Phi)^2 \right) \ .
    \label{eq:freeEnergy}
    \end{align}

    Substituting this into the Allen-Cahn equation~\ref{eq:allencahn}, the
    final evolution equation used by~\citet{zhiyang} and for this thesis is
    \begin{align}
    \frac{d\Phi}{dt} = M ( \epsilon^2 \nabla^2 \Phi
                          + 6 \dGv \Phi (1-\Phi)
                          - 2 W \Phi (1-\Phi) (1-2\Phi) ) \ .
    \label{eq:pfderivative}
    \end{align}

  \subsection{Nucleation in the Phase Field Model}
    Nucleation occurs due to thermal noise.
    It is possible to include a Langevin noise in the phase field evolution
    equation.
    Using this method in computational simulations, a high spatial resolution
    and small time steps are necessary to reproduce
    physical nucleation rates~\citep{PFMintro1}.
    
    Alternatively, nucleation can be included ad-hoc using analytical
    expressions from e.g. classical nucleation theory.
    This is a commonly used technique in phase field
    simulations~\citep{PFMintro1}.
    
    In appropriate time steps and volume elements,
    the local nucleation probability is calculated
    and compared to random numbers.
    For each nucleation event, some initial shape is added into the phasefield.
    The determination of this shape can alone be a challenging task depending on
    material properties~\citep{SmoothBoundaryNucleiAlgorithm}.
  
  \subsection{Analytical Solutions}
    From the used phase field equation,
    some simple settings can be solved analytically.
    The results can be used to express the coefficients in the equation
    through other parameters,
    that are possibly measureable in experiments
    or that have a clear defined meaning as numerical parameters.
  
    \subsubsection{Interface Form}
      As done in ref.~\citep{PFMSolidification}, the equilibrium interface shape
      can be calculated.
      For $\dGv = 0$, the equation is symmetric with respect to $\Phi = 0.5$.
      Thus, a planar interface does not move to a prefered side,
      but relaxes into an equilibrium shape.
      Consider such an interface in the $x$-direction
      ($\Phi$ does not depend on $y$ or $z$).
      For the eqilibrium shape, $\frac{d\Phi}{dt} = 0$ and thus
      \begin{align}
       \epsilon^2 \nabla^2 \Phi &= 2 W \Phi (1-\Phi) (1-2\Phi)
          = \frac{\partial}{\partial\Phi} W \Phi^2 (1-\Phi)^2 \\
       \frac{\epsilon^2}{2} \left( \frac{d\Phi}{dx} \right)^2 &= W \Phi^2 (1-\Phi)^2 \\
       \frac{\epsilon}{\sqrt{2 W}}\frac{d\Phi}{dx} &= \Phi(1-\Phi) \ .
      \end{align}
      Together with the boundary conditions of one phase ($\Phi=0$) on the left
      side ($x\rightarrow-\infty$)
      and the other ($\Phi=1$) on the right side ($x\rightarrow+\infty$),
      this equation is solved by
      \begin{equation}
       \Phi = \frac{1}{2} \left( 1 + \tanh\left( \frac{x}{2\zeta} \right)\right)
       \label{eq:interfaceform}
      \end{equation}
      with the interface thickness
      \begin{equation}
       \zeta = \frac{\epsilon}{\sqrt{2W}} \ .
      \end{equation}
      The shape does only reach $\Phi = 0$ and $\Phi = 1$ for infinite $x$.
      Thus, it has not really a thickness.
      $\zeta$ is however a characteristic length scale for the function.
      
      The width on which order parameters vary between the eqilibrium values
      in real systems can be as smaller than a nanometer~\citep{AISTpaper}.
      In numerical simulations, the interface must range over several grid points
      for numerical derivatives to give meaningful results.
      Depending on the size of the simulated system
      and the available computational capacity however,
      it is often necessary to use unrealistic large values for this parameter.
      % PFMintro2 say mostly unrealistic values are used
      % PFMSolidification also use ``unrealistic interface thickness''
      This has been done by several authors~\citep{PFMintro2, PFMSolidification}.
      By adjusting other parameters, it is possible to retain consistency in most
      other aspects.
    
    \subsubsection{Interfacial Energy}
      Using the eqilibrium shape derived above in the equation
      for the free energy,
      one can derive the free energy of the interface $\gamma$.
      This was done in ref.~\citep{PFMSolidification}.
      Consider again the system with a stable interface in the $x$-direction
      that does not depend on $y$ or $z$.
      To receive the interfacial energy, integrate over an area in the $xy$
      plane and the width in the $x$-direction and divide it by the area.
      As $\Phi$ does not depend on $y$ and $z$, the integration over the plane
      cancels out the division by the area.
      The width is, for this shape, the whole axis.
      \begin{align}
      \gamma &= \int_{-\infty}^{\infty} \frac{\epsilon^2}{2}(\nabla\Phi)^2 + W\Phi^2(1-\Phi)^2 dx \\
             &= \int_{-\infty}^{\infty} \epsilon^2(\nabla\Phi)^2 dx \\
             &= \int_{-\infty}^{\infty} \frac{\epsilon^2}{4} \left( \frac{d}{dx}
                  \left( 1 + \tanh\left( \frac{x}{2\zeta} \right)\right) \right)^2  dx \\
             &= \frac{\epsilon^2}{6\zeta} \ .
%             &= \frac{\epsilon}{3} \sqrt{\frac{W}{2}}
      \end{align}
      
      In the second step the definition of the interface form is used.
      
      The interfacial energy is a physical parameter.
      As the phase field time evolution is however invariant under a scaling of
      all energies, only its ratio to the other energy $\dGv$ is relevant.
    
    \subsubsection{Growth Velocity}
      The equilibrium shape of a planar interface gives also a solution for
      a system with a bulk free energy $\neq 0$.
      Consider again the planar interface derived above and change $\dGv$.
      In this system, the interface moves with a constant velocity $v$:
      \begin{equation}
       \Phi(x,t) = \frac{1}{2} \left( 1 + \tanh\left( \frac{x+vt}{2\zeta} \right)\right)
      \end{equation}
      
      This is achieved through a good choice of the free energy function,
      which was taken from ref.~\citep{PFMSolidification} together with this
      calculation.
      For $v$ one gets
      \begin{align}
       \frac{d\Phi}{dt} &= M \cdot 6\Phi(1-\Phi)\dGv \\
       \frac{v}{4 \zeta \cosh^2(\frac{x+vt}{2\zeta})} &=
          M\frac{6 \dGv}{4 \cosh^2(\frac{x+vt}{2\zeta})} \\
       v &= 6 M \zeta \dGv \ .
         \label{eq:velocity}
      \end{align}
      
      The growth velocity is an easy measureable quantity for which
      data and different models are available,
      as presented in section~\ref{sec:theo:v}.
    
    \subsubsection{Relaxation of Interface Shape}
      As seen in equation~\ref{eq:velocity},
      the growth velocity $v$ is proportional to the interface thickness $\zeta$.
      In a simulation with $M$, $\epsilon$, $W$ and $\dGv$ set to values to
      match a numerical reasonable $\zeta$ and physical observed $v$,
      a steeper or less steep interface might appear that does not grow
      with the desired velocity.
      It is then of interest after which time the interface relaxes into the
      eqilibrium shape.
      To investigate this, consider a planar interface of the shape derived for
      the eqilibrium, in a system with $\dGv = 0$, 
      but with a different thickness $l \neq \zeta$.
      \begin{align}
       \Phi &= \frac{1}{2} \left( 1 + \tanh\left( \frac{x}{2l} \right)\right) \\[.5ex]
       \frac{d\Phi}{dt} &= M \left( \epsilon^2 \frac{-\tanh(\frac{x}{2l})}{\cosh^2(\frac{x}{2l})} \frac{1}{4l}
			      + \frac{1}{2} W \frac{\tanh(\frac{x}{2l})}{\cosh^2(\frac{x}{2l})} \right) \\[.5ex]
			&= \frac{MW}{2l^2} (l^2-\zeta^2) \frac{\tanh(\frac{x}{2l})}{\cosh^2(\frac{x}{2l})} \\[.5ex]
			&= M W \, \frac{l-\zeta}{l} \, \frac{l+\zeta}{2l} \, \frac{\tanh(\frac{x}{2l})}{\cosh^2(\frac{x}{2l})}
      \end{align}
      Approximating $l \approx \zeta$, the first fraction becomes a relative
      deviation from the equilibrium shape.
      The second fraction is approximatly one.
      The last fraction gives the dependence on $x$ and is not equal to the
      form one gets for the time derivative of $\Phi$ with a time dependent $l$.
      This means that the form is not preserved.
      It is however just a dimensionless factor that varies from $0$ to $0.4$
      across the interface region.
      Thus, the prefactor $\frac{1}{\tau} = M W$ can be seen as an inverse time
      constant for the relaxation.
      
      This parameter has no physical meaning in most settings,
      where the interface form is choosen to fit the spatial resolution
      of the simulation rather than the physical width
      or where the smooth interface region is only introduced to apply a pahse
      field simulation.
      It is proposed as a measure of numerically for the stability of the
      simulation under variation of the interface form.
      However, it is mostly not a free parameter if other properties are set
      to fixed values.
    
    \subsubsection{Characteristic Length Scale}
      Next to the diffuse interface thickness $\zeta$, another characteristic
      length arises from the parameters when dividing the interfacial energy
      $\gamma$ by the bulk free energy $\dGv$.
      In classical nucleation theory,
      a similar factor $r_c = \frac{2\gamma}{\dGv}$ appears
      as the critical size for a nucleus.
      In a sharp interface model, a smaller nucleus shrinks while a larger one
      grows.
      It is also the length scale on which the Gibbs-Thomson effect matters.
      Using the solutions above in equation~\ref{eq:gibbsthompson},
      one gets
      \begin{equation}
       \frac{dr}{dt} = v \left( 1 - \frac{r_c}{2 r} \right) \ .
      \end{equation}

      Thus, this length can be considered as the length scale at which
      curvatures are penalized.
      
      As the initial size of grains and length scale of the Gibbs-Thomson
      effect, this parameter has a physical meaning.
      In a discretized implemetation however, it has another effect,
      which will be analysed in section~\ref{sec:num_rcrit}.
      For this reason, it might be necessary to use unphysically large values.
      This will lead to a loss of detail for small grains.
      
  \subsection{Dependence of Parameters}
    In the evolution equation~\ref{eq:pfderivative} there are three independent
    parameters: $M \epsilon^2$, $M W$ and $M \dGv$.
    They can be expressed by combinations of the properties derived in the
    previous section.
    
    \paragraph{1.}
    In the simulation of~\citeauthor{zhiyang}, an interface thickness $\zeta$ in
    the order of magnitude as the physical width was used.
    The interfacial energy $\gamma$ was also taken from experimental data.
    For the growth velocity, a combination of the viscosity model for
    temperatures over the glass transition temperature and an Arrhenius model
    for lower temperatures was used.
    By adjusting M, this leaves the freedom of choosing $\dGv$ according to the
    presented physical model and thus receive physical sensible results
    not only for the crystallization kinetics, but also for the free energy.
    Summarizing, the parameters were calculated as 
    \begin{align}
     \epsilon &= \sqrt{6 \gamma \zeta} \\
     W &= \frac{3 \gamma}{\zeta} \\
     M &= \frac{v}{6 \zeta \dGv}
    \end{align}
    using only physically sensible values on the right side of these equations.
    
    With this, the critical radius $r_c = \frac{2 \gamma}{\dGv}$ is fixed.
    As a numerical simulation has to resolve both $\zeta$ and $r_c$,
    the spatial resolution is restricted to very small values.
    \Citeauthor{zhiyang} uses $\SI{0.5}{\nm}$ as grid point spacing.
    The available computational capacity then determines the largest
    settings that can be simulated. \\
    Furthermore, the relaxation time constant $\tau$ is given
    as $\frac{4 \zeta^2}{r_c v}$. For $r_c \approx \zeta$,
    one gets $\tau \approx \frac{4 \zeta}{v}$, which is the time in which an
    interface moves by approximately the interface thickness.
    This means that pertubed interfaces relax to their equilibrium shape fast
    enough to have no significant influence on the kinetics.
    
    \paragraph{2.}
    Another possible approach is to choose both length scales,
    $\zeta$ and $r_c$,
    according to the used resolution.
    As a third free variable $v$ can be choosen from a physical model.
    The parameters of the evolution equation are then calculated as
    \begin{align}
     M \epsilon^2 &= \frac{v r_c}{2} \\[.5ex]
     M W &= \frac{v r_c}{4 \zeta^2} \\[.5ex]
     M \dGv &= \frac{v}{6 \zeta} \ .
    \end{align}

    This gives much greater freedom in the choice of the simulated sample.
    It leads however to a loss of detail. %TODO analyse this
    As neither $\dGv$ nor $\gamma$ are used as independent parameters,
    the free choice of $M$ can not be used to set all energy terms to physically
    sensible values.
    Hence, the free energy of the system will not have an interpretation.
    
    For the relaxation time $\tau$, the same arguments as above are valid.
    
    \paragraph{3.}
    For tests purposes, it might be of interest to set the relaxation time
    $\tau$ to a defined value rather than $r_c$.
    This is especially the case for $v=0$, which will lead to all parameters
    vanishing in the method above, as for $r_c < \infty$ and $\zeta > 0$
    it implies $M = 0$.
    
    In this case, the parameters are calculated as
    \begin{align}
     M \epsilon^2 &= \frac{2 \zeta^2}{v} \\
     M W &= \frac{1}{\tau} \\
     M \dGv &= \frac{v}{6 \zeta} \ .
    \end{align}
    
    \paragraph{}
    This discussion did not include the nucleation rate, which does not appear
    in the time evolution equation.
    In an actual simulation it is a fourth free parameter.
    It may depend on some of the parameters above as long as they are given
    physically reasonable values.
    Apart from this however, for ad-hoc implemented nucleation, the phase field
    evolution is relatively independend from it.
    
\section{Numerical Methods}
  The phase field model describes continuous fields or even approximates
  non continuous fields with smooth functions.
  For computational calculations however, the field has to be represented by a
  finite number of discrete values.
  There is a wide range of techniques used for this, out of which only the used
  ones will be presented here.
  
  \subsection{Finite Differences}
    The simulation is implemented using a finite difference
    algorithm~\citep{zhiyang}.
    This is the most direct approach,
    easy to parralelize for the computation on multiple processors
    and low in computational expense~\citep{ProgrammingPFM}.
    The continuous phase field $\Phi$ is discretized and represented
    by its values at a finite number of points~\citep{stencilLaplace}.
    The set of all these points is called grid.
    For this implemetation, a uniform grid with evenly spaced points is used.
    A more dense sampling at interesting sectors can be usefull for complex
    geometries~\citep{sebastiansThesis},
    a time dependent adaptive grid can even adjust the precision to use more
    point at, e.g. for this application, phase borders.
    As this is however itself coupled with computational effort,
    most simulations use a uniform grid~\citep{PFMintro3}.
    
    The distance between two neighbouring points is called
    gird point spacing $h$~\citep{stencilLaplace} and
    determines the spatial resolution of the simulation.
    In a uniform grid, it is a constant.
    A small value offers better precision, but the number of necessary points 
    and thus the computational effort is proportional to $1/h$ to the power of
    the dimensions of the sample.
    
    The crucial part of the discretization is the calculation of derivatives.
    In the phase field evolution equation \ref{eq:pfderivative},
    the Laplacian of $\Phi$ appears.
    In a one dimensional problem, it can be approximated by the centered second
    difference~\citep{ProgrammingPFM}
    \begin{equation}
     \nabla^2 \Phi_n \approx \frac{\Phi_{n-1} - 2\Phi_n + \Phi_{n+1}}{h^2} \ ,
    \end{equation}
    where $\Phi_{n-1}$ and $\Phi_{n+1}$ are the neighbouring points to $\Phi_n$.
    In three dimensions however, the situation is more complex.
    Consider a point in a uniform grid as the center of a cube with a side
    length of $2h$, as shown in figure~\ref{fig:uniformgirdneighbours}.
    It has 6 nearest neighbours with a distance of $h$,
    associated with the faces of the cube.
    There are 12 neighbouring points with a distance of $\sqrt{2}h$ at the edges
    and another 8 with a distance of $\sqrt{3}h$ in the corners.
    
    The standard approximation is called 7-point stencil, as it uses the point
    and 6 neighbours~\citep{stencilLaplace}.
    The Laplacian is approximated by
    \begin{equation}
     \nabla^2 \Phi_{x,y,z} \approx \frac{\Phi_{x-1,y,z} + \Phi_{x,y-1,z} +
        \Phi_{x,y,z-1} - 6 \Phi_{x,y,z} + \Phi_{x+1,y,z}
        + \Phi_{x,y+1,z} + \Phi_{x,y,z+1}}{h^2} \ ,
    \end{equation}
    where $x$, $y$ and $z$ are integer coordinates.
    Higher order stencils consider additional points:
    The 19-point stencil uses additional the 12 points at the edges,
    the 27-point stencil takes also the points in the corners into account.
    While they are more expensive to calculate,
    they can reduce the anisotropies introduced by the grid
    and offer more numerical stability~\citep{stencilLaplace}.
    
    In the original implementation by \citet{zhiyang} a 7-point stencil was
    used, which was adopted for this work.
    
    \begin{figure}[tbp]
     \centering
     \includegraphics[width=.5\linewidth]{../img/laplacian.png}
     \caption{Neighbouring points in a three dimensional uniform grid.
         The 6 nearest points with a distance of $h$ sit on the faces,
         the 12 points on the edges have a distance of $\sqrt{2}h$,
         the 8 points in the corners $\sqrt{3}h$.
         Image taken from ref.~\citep{stencilLaplace}.}
     \label{fig:uniformgirdneighbours}
    \end{figure}
  
  \subsection{Time Stepping Scheme}
    Similar to the spatial discretization,
    the time evolution must be discretized to calculate with a finite number
    of computer operations.
    Instead of a continuous time $t$, discrete time values $t_n$ are used.
    The difference $\Delta t$ between them is called time step.
    
    To calculate the next state $\Phi_{n+1}$ from the current state $\Phi_n$,
    the time evolution equation is approximated.
    The simplest method is called explicit euler scheme~\citep{ProgrammingPFM}.
    It uses
    \begin{equation}
     \frac{d\Phi}{dt} \approx \frac{\Phi_{n+1}-\Phi_n}{\Delta t}
    \end{equation}
    to calculate
    \begin{equation}
     \Phi_{n+1} = \Phi_n + \frac{d\Phi_n}{dt} \cdot \Delta t
    \end{equation}
    where $\frac{d\Phi_n}{dt}$ is calculated putting $\Phi_n$ into the
    physical evolution equation, here given by eq.~\ref{eq:allencahn}.
    
    This formula approximates the derivative to be constant over the time
    interval $\Delta t$, which leads to deviations from the analytical solution.
    These can be, to some extend, corrected
    in a second step~\citep{ProgrammingPFM}.
    The explicit euler scheme is used to calculate a first estimation
    $\tilde{\Phi}_{n+1}$.
    This estimation is then used to anticipate the changes of the evolution
    equation during $\Delta t$.
    The subsequent state is then calculated as
    \begin{equation}
     \Phi_{n+1} = \Phi_n + \frac{1}{2} \left( \frac{d\Phi_n}{dt} +
        \frac{d\tilde{\Phi}_{n+1}}{dt} \right) \Delta t
    \end{equation}
    This algorithm is called predictor-corrector scheme~\citep{zhiyang}.
    The computational effort for this calculation is about twice as high as
    for the explicit euler scheme,
    so this method has to be compared to an explicit euler scheme with half
    the time step.
    
    In the original implementation by \citet{zhiyang} as well as in
    this work, a predictor-corrector scheme is used,
    which can however easily be swiched.

  \clearpage
  \subsection{Numerical stability}
    The presented discretizations introduce some errors to the solution.
    It is then important that these errors do not build up to larger
    and larger deviations.
    If this is not the case independend from the initial setup,
    the algorithm is called numerical stable.

    For a 7-point stencil Laplacian and a simple diffusion equation 
    $\frac{d\Phi}{dt} = D \frac{d^2\Phi}{dx^2}$,
    numerical stability can be proven for~\citep{stencilLaplace} 
    \begin{equation}
     dt \leq \frac{h^2}{6 D}\ .
    \end{equation}
    As the used phase field evolution equation is similar,
    this so called Von-Neumann criterion was used by \citet{zhiyang} as an
    estimation for the maximal useable timestep.
    With the variables introduced here, it is formulated as
    \begin{equation}
     dt \leq \frac{h^2}{6 M \epsilon^2} = \frac{h^2}{3 v r_c} \ .
     \label{eq:numstab}
    \end{equation}
